''*****************************
''*  Graphics Demo            *
''*  (C) 2005 Parallax, Inc.  *
''*****************************


CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  x_tiles = 16
  y_tiles = 12

  paramcount = 14

  TextHeight=11
  TextWidth=6
  

VAR
  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[64]
  
  long bitmap[$C00+64/4]

  word firstWindow

OBJ

  tv      : "tv"
  gr      : "graphics"
  win[3]  : "window"
  text[2] : "Text"
  vec     : "VecSprit"
  txBox   : "TextBox"
  pix[5]  : "PixSprit"

PUB start | i, j, k, kk, dx, dy, pp, pq, rr, numx, numchr

  'start tv
  longmove(@tv_status, @tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)

  'init colors
  repeat i from 0 to 63
    colors[i] := $00001010 * (i+4) & $F + $2B060C02

  'init tile screen
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := (@bitmap+63) >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)
               '                    divide by 64 add row add column add color shifted 

  'start and setup graphics
  gr.start
  gr.setup(16, 12, 0, 0, ((@bitmap+63)>>6) <<6)

  'clear bitmap
  gr.clear

  win[0].setPosition(100,20)
  win[0].setSize(120,100)
  win[0].setTitle(string("Window 1"))
  win[0].register(text[0].getStart)
  
  win[1].setPosition(10,100)
  win[1].setSize(120,70)
  win[1].setTitle(string("Window 2"))

  win[2].setPosition(20,20)
  win[2].setSize(130,130)
  win[2].setTitle(string("Window 3"))

  text[0].setPosition(10,10)
  text[0].setScale(1)
  text[0].setJust(0)
  text[0].setText(string("Some text"))

  vec.setPosition(50,90)
  vec.setScale(1)
  vec.setRotation((2 & $7F) << 3 + 2 << 5)
  vec.setVec(@vecDef)

  win[2].register(vec.getStart)

  repeat i from 0 to 4
    pix[i].setPosition(10+20*i,70)
    pix[i].setRotation(0)
    pix[i].setPix(@pixdef2)
    win[2].register(pix[i].getStart)

  
  txBox.setPosition(10,10)
  txBox.setSize(100,50)
  txBox.setText(string("This is a text box. The text should wrap around and not go out of the box."))
  txBox.setStart(0)
  txBox.setScale(1)

  win[2].register(txBox.getStart)
  
  register(win[0].getStart)
  register(win[1].getStart)
  register(win[2].getStart)

  setTop(win[1].getStart)

  redraw

  waitcnt(cnt)

  text[1].setPosition(10,70)
  text[1].setScale(2)
  text[1].setJust(0)
  text[1].setText(string("Some more"))

  vec.setScale(1)

  setTop(win[2].getStart)

  redraw

  win[2].setSize(200,130)
  win[2].register(text[1].getStart)

  txBox.setStart(0)
  txBox.setSize(180,48)

  waitcnt(cnt)

  drawWindowContents(win[2].getStart)
 
PUB register(window)|i
  if firstWindow==0    'if this is the first window then make it the first windos
    firstWindow:=window
    return

  i:=firstWindow

  repeat
    if word[i]==0
      word[i]:=window
      return

    i:=word[i]   
  
PUB redraw|window
  'redraws the screen. Calls the getWindow method in each of the registered window objects
  'the getWindow method needs to return a pointer to the window data
  'word x_position
  'word y_position
  'word width
  'word height
  'word string_ptr
  ''''''''''''''''''''''''
  'word type - 0,1,2,3,4,5 - no more, color, text, vec sprite, pix sprite, text box

  gr.clear
  window:=firstWindow
  repeat until window==0
    drawWindowContents(window)
    window:=word[window]

  
      
PUB drawWindow(xp,yp,w,h,title)
  gr.color(1)   'draw window background
  gr.box(xp,yp,w,h)
  
  gr.color(3)   'draw window border
  gr.plot(xp,yp)
  gr.line(xp+w,yp)
  gr.line(xp+w,yp+h)
  gr.line(xp,yp+h)
  gr.line(xp,yp)
  
  gr.color(2)    'draw window title
  gr.textmode(1,1,6,%0101)
  gr.text(xp+w/2,yp+h-10,title)

PUB drawWindowContents(window)|wx,wy,ptr
      wx:=word[window+2]
      wy:=word[window+4]
      drawWindow(wx,wy,word[window+6],word[window+8],word[window+10])

      ptr:=word[window+12]
  
      'Loop through and draw window contents
      repeat until ptr==0
        case word[ptr+2]
          0:   'no more
            quit
          1:   'change color
            gr.color(ptr)
          2:   'text
            gr.textmode(word[ptr+10],word[ptr+10],6,word[ptr+8])
            gr.text(word[ptr+4]+wx+1,word[ptr+6]+wy+1,word[ptr+12])
            gr.finish
          3:   'vector sprite
            gr.vec(word[ptr+4]+wx+1, word[ptr+6]+wy+1, word[ptr+10], word[ptr+8], word[ptr+12])
            gr.finish
          4:   'pix sprite
            gr.pix(word[ptr+4]+wx+1,word[ptr+6]+wy+1,word[ptr+8],word[ptr+10])
            gr.finish
          5:   'draw textBox
            drawTextBox(word[ptr+4]+wx+1,word[ptr+6]+wy+1,word[ptr+8],word[ptr+10],word[ptr+16],word[ptr+12])
        'next item
        ptr:=word[ptr]

PUB drawTextBox(xp,yp,w,h,textPtr,startLine)|maxLines,maxWidth,i,stringEnded,startPtr,endPtr,z,numLines,countLines
  gr.color(0)
  gr.box(xp,yp,w,h)

  gr.color(3)
  gr.plot(xp,yp)
  gr.line(xp+w,yp)
  gr.line(xp+w,yp+h)
  gr.line(xp,yp+h)
  gr.line(xp,yp)

  'figure out how many lines and columns of text that we can draw
  maxLines:=(h-4)/TextHeight
  maxWidth:=(w-4)/TextWidth-1

  gr.color(2)

  'set up the justification
  gr.textMode(1,1,6,0)

  'scan through the string until we get to the maximum width
  'when we get to the max width, go backward until we find a space
  'if we dont find a space, just wrap it onto the next line
  'if we find a space, replace it with a 0 and print the line
  'then repeat until we reach the end of the string

  stringEnded:=false
  startPtr:=textPtr
  yp:=yp+h-TextHeight-2
  countLines:=0

  repeat
    'scan foward until we get to max width or the end of the string
    repeat endPtr from startPtr to startPtr+maxWidth
      if byte[endPtr]==0
        stringEnded:=true
        quit
    
    if stringEnded
      'print string
      if (countLines=>startLine) & (countLines<MaxLines+startLine)
        gr.text(xp+2,yp,startPtr)
      return
      
    else
      'go backwards until we find a space
      repeat i from 0 to maxWidth
        if byte[endPtr-i]==" "
          endPtr:=endPtr-i
          byte[endPtr]:=0 'make the space the end of the string until we print it
          quit

      if (countLines=>startLine) & (countLines<MaxLines+startLine)
        'print string
        gr.text(xp+2,yp,startPtr)
        gr.finish

      if byte[endPtr]==0
        'put space back
        byte[endPtr]:=" "

    'fix up the pointers so that we are ready for the next bit
    startPtr:=endPtr+1
    if countLines=>startLine
      yp:=yp-TextHeight
    countLines++
  
PUB removeWindow(window)|i
  'find window before window
  i:=firstWindow
  
  repeat until word[i]==window
    i:=word[i]

  'point around window
  word[i]:=word[window]
  
PUB setTop(window)
  removeWindow(window)
  register(window)
  word[window]:=0
  
DAT

tvparams                long    0               'status
                        long    1               'enable
                        long    %001_0101       'pins
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog

vecdef                  word    $4000+$2000/3*0         'triangle
                        word    50
                        word    $8000+$2000/3*1+1
                        word    50
                        word    $8000+$2000/3*2-1
                        word    50
                        word    $8000+$2000/3*0
                        word    50
                        word    0

vecdef2                 word    $4000+$2000/12*0        'star
                        word    50
                        word    $8000+$2000/12*1
                        word    20
                        word    $8000+$2000/12*2
                        word    50
                        word    $8000+$2000/12*3
                        word    20
                        word    $8000+$2000/12*4
                        word    50
                        word    $8000+$2000/12*5
                        word    20
                        word    $8000+$2000/12*6
                        word    50
                        word    $8000+$2000/12*7
                        word    20
                        word    $8000+$2000/12*8
                        word    50
                        word    $8000+$2000/12*9
                        word    20
                        word    $8000+$2000/12*10
                        word    50
                        word    $8000+$2000/12*11
                        word    20
                        word    $8000+$2000/12*0
                        word    50
                        word    0

pixdef                  word                            'crosshair
                        byte    2,7,3,3
                        word    %%00333000,%%00000000
                        word    %%03020300,%%00000000
                        word    %%30020030,%%00000000
                        word    %%32222230,%%00000000
                        word    %%30020030,%%02000000
                        word    %%03020300,%%22200000
                        word    %%00333000,%%02000000

pixdef2                 word                            'dog
                        byte    1,4,0,3
                        word    %%20000022
                        word    %%02222222
                        word    %%02222200
                        word    %%02000200

pchip                   byte    "Propeller",0           'text